
//更新頁
RemoteMqttGroupUpdatePage.prototype._Initialization_ = function()
{
	$("#Main_Center-Content").find(".Body").hide();
	$("#Main_Center-Content").find(".Body").eq(0).show();

	if(RemoteMqttGroupUpdatePage.prototype._IsSaveGlobalVariable_() == true)
	{
		RemoteMqttGroupUpdatePage.prototype._ShowFirstPage_();
		return 0;
	}
	var Row = $("#Main_Center-Content").find(".Body").eq(0).find(".Table").find(".Row");
	RemoteMqttGroupUpdatePage.prototype._SaveGlobalVariable_(Row);
}
RemoteMqttGroupUpdatePage.prototype._IsSaveGlobalVariable_ = function()
{
	var Return=false;
	var Class = new LoadFile();
	var RemoteBroker = Class.ReadFile("./File/IoT_Platform/RemoteBroker.json", new Array());
	
	if(JSON.stringify(RemoteBroker)==JSON.stringify(Global_RemoteBroker))
	{
		Return=true;
	}
	return Return;
}
RemoteMqttGroupUpdatePage.prototype._ShowFirstPage_ = function()
{
	$("#Main_Center-Content").find(".Body").hide();
	$("#Main_Center-Content").find(".Body").eq(1).show();
	RemoteMqttGroupFirstPage.prototype._Initialization_();
}

















//第1頁
RemoteMqttGroupFirstPage.prototype._InitialRemoteMqttGroupObject_ = function(that)
{
	var number = Object.keys(Global_RemoteMqttGroup);
	if(number.length == 0)
	{
		number=1;
	}
	else if(number.length>0)
	{
		number = Math.max.apply(null,number)+1;
	}
	if(typeof(Global_RemoteMqttGroup[number]) == "undefined")
	{
		Global_RemoteMqttGroup[number] = new Object();
		Global_RemoteMqttGroup[number]["Name"] = $(that).closest(".Row").find(".Column").eq(2).find(".Text").val();			
		Global_RemoteMqttGroup[number]["DataMessage"] = "";
		Global_RemoteMqttGroup[number]["ConnectionGroup"] = "";
		Global_RemoteMqttGroup[number]["TransformMqttJson"] = "";
	}
}
RemoteMqttGroupFirstPage.prototype._AddNewRow_ = function(that)
{
	RemoteMqttGroupFirstPage.prototype._CheckGroupName_();
	var Id = "#GroupTable";
	var ShowErrorMessage = $(Id).find(".Row").eq(0).find(".Message").is(":visible");
	if(ShowErrorMessage == true)	{return 0;}
	RemoteMqttGroupFirstPage.prototype._InitialRemoteMqttGroupObject_(that);
	RemoteMqttGroupFirstPage.prototype._RedisplayUi_();
	RemoteMqttGroupFirstPage.prototype._AutomaticGroupName_();
}

RemoteMqttGroupFirstPage.prototype._Initialization_ = function()
{
	RemoteMqttGroupFirstPage.prototype._RedisplayUi_();
}

RemoteMqttGroupFirstPage.prototype._RedisplayUi_ = function()
{
	var DisplayNumber = 5;
	var ObjectKey = RemoteMqttGroupFirstPage.prototype._GetAllNumber_();
	RemoteMqttGroupFirstPage.prototype._UpdateTableToolbar_(ObjectKey, DisplayNumber);
	RemoteMqttGroupFirstPage.prototype._ShowTable_(ObjectKey, DisplayNumber);
	var Id = "#GroupTable";
	$(Id).find(".Row").eq(0).find(":checkbox").prop("checked",false);
}

RemoteMqttGroupFirstPage.prototype._GetAllNumber_ = function()
{
	var ObjectKey = Object.keys(Global_RemoteMqttGroup);
	return ObjectKey;
}

RemoteMqttGroupFirstPage.prototype._UpdateTableToolbar_ = function(ObjectKey, DisplayNumber)
{
	var NumberOfPages = Math.ceil(ObjectKey.length/DisplayNumber);
	var Id = "#GroupToolbar";
	$(Id).find("label").eq(1).text(NumberOfPages);
	var CurrentlyPage = $(Id).find(".Text").val();
	CurrentlyPage = parseInt(CurrentlyPage);
	if(CurrentlyPage>NumberOfPages)
	{
		$(Id).find(".Text").val(NumberOfPages);
	}
	else if(CurrentlyPage<=0 || isNaN(CurrentlyPage)==true)
	{
		$(Id).find(".Text").val(1);
	}
	else
	{
		$(Id).find(".Text").val(CurrentlyPage);
	}
}

RemoteMqttGroupFirstPage.prototype._ShowTable_ = function(ObjectKey, DisplayNumber)
{
	$("#GroupTable").find(".DynamicRow").remove();
	var html = $(".Dynamic").html();
	var PageNumber = $("#GroupToolbar").find(".Text").val();
	var Start = (PageNumber-1)*DisplayNumber;
	if((ObjectKey.length-Start)>DisplayNumber){
		var End = Start + DisplayNumber;
	}
	else{
		var End = ObjectKey.length;
	}
	var index = 0;
	for(var i=Start; i<End && End!=0; i++)
	{
		$("#GroupTable").append(html);
		$("#GroupTable").find(".DynamicRow").eq(index).find(".Column").eq(0).text(ObjectKey[i]);
		$("#GroupTable").find(".DynamicRow").eq(index).find(".Column").eq(2).text(Global_RemoteMqttGroup[ObjectKey[i]]["Name"]);
		index++;
	}
}

RemoteMqttGroupFirstPage.prototype._CheckGroupName_ = function(that)
{
	var Id = "#GroupTable";
	$(Id).find(".Message").hide();
	var Row=$(Id).find(".Row");
	var Name = Row.eq(1).find(".Text").val();
	var Class = new Type();
	if(Class.EnglishDigitalAndBottomline(Name) == false)
	{
		Row.eq(0).find(".Message").eq(0).show();
	}
	Class = null;
	if(RemoteMqttGroupFirstPage.prototype._IsNameRepeat_(Name) == true)
	{
		Row.eq(0).find(".Message").eq(1).show();
	}
}

RemoteMqttGroupFirstPage.prototype._IsNameRepeat_ = function(Name)
{
	var Return=false;
	var Row = $("#Main_Center-Content").find(".Body").eq(1).find(".Form").eq(0).find(".Row");
	var CurrentlyNumber = Row.eq(0).find(".Text").val();
	var number = Object.keys(Global_RemoteMqttGroup);
	for(var i=0; i<number.length; i++)
	{
		if(Name == Global_RemoteMqttGroup[number[i]]["Name"])
		{
			Return=true;
			break;
		}
	}
	return Return;
}

RemoteMqttGroupFirstPage.prototype._AutomaticGroupName_ = function()
{
	var Table = $("#Main_Center-Content").find(".Body").eq(1).find(".Table").eq(0);
	var Index = 1;
	var object = jQuery.parseJSON(JSON.stringify(Global_RemoteMqttGroup));
	var number = Object.keys(object);
	var Name, NameArray=new Array();
	for(var i=0; i<number.length; i++)
	{
		NameArray.push(object[number[i]]["Name"]);
	}
	while(true)
	{
		Name = "Name"+Index;
		if(NameArray.indexOf(Name) == -1)
		{
			break;
		}
		Index++;
	}
	Table.find(".Row").eq(1).find(".Text").val(Name);
}

RemoteMqttGroupFirstPage.prototype._ChangeAllCheckbox_ = function(that)
{
	var TableId = $(that).closest(".Table").attr("id");
	var Bool = $(that).closest(".Row").find(":checkbox").prop("checked");
	var Element = $("#"+TableId).find(".DynamicRow");
	Element.prop("checked",Bool);
	for(var i=0; i<Element.length; i++)
	{
		if(Element.eq(i).find(":checkbox").prop("checked") != Bool)
		{
			Element.eq(i).find(":checkbox").click();
		}
	}
}

RemoteMqttGroupFirstPage.prototype._IsTickedGroup_ = function()
{
	var Return=false;
	var Id = "#GroupTable";
	if($(Id).find(".DynamicRow").find(":checked").length >0)
	{
		Return=true;
	}
	return Return;
}

RemoteMqttGroupFirstPage.prototype._DeleteRow_ = function(that)
{
	var Id = "#GroupTable";
	var element = $(Id).find(".DynamicRow").find(":checked");
	var CheckedLength = element.length;
	for(var i=0; i<CheckedLength; i++)
	{
		var number = element.eq(i).closest(".DynamicRow").find(".Column").eq(0).text();
		RemoteMqttGroupFirstPage.prototype._RemoveGroup_(number);
	}
	RemoteMqttGroupFirstPage.prototype._RedisplayUi_();
}

RemoteMqttGroupFirstPage.prototype._RemoveGroup_ = function(number)
{
	var GroupName = Global_RemoteMqttGroup[number]["Name"];
	Global_RemoteMqttGroup[number] = null;	delete Global_RemoteMqttGroup[number];
	
	RemoteMqttGroupFirstPage.prototype._RemoveRtuToRemoteMqttGroupName_(GroupName);
	RemoteMqttGroupFirstPage.prototype._RemoveTcpToRemoteMqttGroupName_(GroupName);
	RemoteMqttGroupFirstPage.prototype._RemoveAsciiToRemoteMqttGroupName_(GroupName);
}

RemoteMqttGroupFirstPage.prototype._RemoveRtuToRemoteMqttGroupName_ = function(GroupName)
{
	var object = jQuery.parseJSON(JSON.stringify(Global_RtuToMqttJsonVariable));
	var number=Object.keys(object);
	for(var i=0; i<number.length; i++)
	{
		var Variable = Object.keys(object[number[i]]);
		for(var j=0; j<Variable.length; j++)
		{
			if(GroupName == object[number[i]][Variable[j]]["ConnectionGroup"])
			{
				Global_RtuToMqttJsonVariable[number[i]][Variable[j]]["ConnectionGroup"] = "";
			}
		}
	}
}

RemoteMqttGroupFirstPage.prototype._RemoveTcpToRemoteMqttGroupName_ = function(GroupName)
{
	var object = jQuery.parseJSON(JSON.stringify(Global_TcpToMqttJsonVariable));
	var number=Object.keys(object);
	for(var i=0; i<number.length; i++)
	{
		var Variable = Object.keys(object[number[i]]);
		for(var j=0; j<Variable.length; j++)
		{
			if(GroupName == object[number[i]][Variable[j]]["ConnectionGroup"])
			{
				Global_TcpToMqttJsonVariable[number[i]][Variable[j]]["ConnectionGroup"] = "";
			}
		}
	}
}

RemoteMqttGroupFirstPage.prototype._RemoveAsciiToRemoteMqttGroupName_ = function(GroupName)
{
	var object = jQuery.parseJSON(JSON.stringify(Global_AsciiToMqttJsonVariable));
	var number=Object.keys(object);
	for(var i=0; i<number.length; i++)
	{
		var Variable = Object.keys(object[number[i]]);
		for(var j=0; j<Variable.length; j++)
		{
			if(GroupName == object[number[i]][Variable[j]]["ConnectionGroup"])
			{
				Global_AsciiToMqttJsonVariable[number[i]][Variable[j]]["ConnectionGroup"] = "";
			}
		}
	}
}

RemoteMqttGroupFirstPage.prototype._ShowPreviousPage_ = function()
{
	var Id = "#GroupToolbar";
	var CurrentlyPage = $(Id).find(".Text").val();
	$(Id).find(".Text").val(parseInt(CurrentlyPage)-1);
	RemoteMqttGroupFirstPage.prototype._RedisplayUi_();
}

RemoteMqttGroupFirstPage.prototype._ShowNextPage_ = function()
{
	var Id = "#GroupToolbar";
	var CurrentlyPage = $(Id).find(".Text").val();
	$(Id).find(".Text").val(parseInt(CurrentlyPage)+1);
	RemoteMqttGroupFirstPage.prototype._RedisplayUi_();
}

RemoteMqttGroupFirstPage.prototype._EditButton_ = function(that)
{
	$("#Main_Center-Content").find(".Body").eq(2).find(".Message").hide();
	var number = parseInt($(that).closest(".DynamicRow").find(".Column").eq(0).text());
	$("#Main_Center-Content").find(".Body").eq(1).hide();
	var Name=$(that).closest(".DynamicRow").find(".Column").eq(2).text();

	$("#Main_Center-Content").find(".Body").eq(2).show();
	$("#Main_Center-Content").css("border-left-width", "0px");
	//$("#Main_Center-Content").css("width", "100%");
	//$("#Main_Left-List").hide();
	
	Name = $("#Main_Center-Content").find(".Body").eq(2).find(".FormTitle").eq(1).text();

	var Class = new Path();
	Class.LoadPathHtml(Name, 2);
	Class = null;
	RemoteMqttGroupSecondPage.prototype._SetInitialValue_(number);
}

RemoteMqttGroupFirstPage.prototype._SaveButton_ = function(that)
{
	that.disabled = true;
	var Result={"Input":null};
	$(that).closest('.Row').find(".Loading").show();
	$(that).closest('.Row').find(".Message").hide();
	RemoteMqttGroupFirstPage.prototype._SaveDataLayerAndServiceLayerVariables_(Result);
	var SetInterval = setInterval(function()
	{
		if(Result["Input"] == true)
		{
			$(that).closest('.Row').find(".Loading").hide();
			$(that).closest('.Row').find(".Message").eq(0).show();
			clearInterval(SetInterval);
			that.disabled = false;
		}
		else if (Result["Input"] != null) {
			clearInterval(SetInterval);
			that.disabled = false;
		}
	},500);
}

RemoteMqttGroupFirstPage.prototype._SaveDataLayerAndServiceLayerVariables_ = function(Result)
{
	var RReturn = $.Deferred();
	var Result_1 = {"Input":null};
	RemoteMqttGroupFirstPage.prototype._SaveModuleSetting_(Result_1);
	//RemoteMqttGroupFirstPage.prototype._SaveConvertSetting_(Result_2);
	//RemoteMqttGroupFirstPage.prototype._SaveLoggerSetting_(Result_3);
	//RemoteMqttGroupFirstPage.prototype._SaveAdvancedSetting_(Result_4);
	var SetInterval = setInterval(function()
	{
		if(Result_1["Input"] == true)
		{
			Result["Input"] = true;
			clearInterval(SetInterval);
			RReturn.resolve(true);
		}
	},500);
	return RReturn.promise();
}

RemoteMqttGroupFirstPage.prototype._SaveModuleSetting_ = function(Result)
{
	var Result_1 = {"Input":null};
	var Class = new Transmission();
	Class.TransmissionString("SaveRemoteMqttGroup", JSON.stringify(Global_RemoteMqttGroup), Result_1);
	//Class.TransmissionString("SaveTcpModule", JSON.stringify(Global_TcpModule), Result_2);
	//Class.TransmissionString("SaveTcpVariable", JSON.stringify(Global_TcpVariable), Result_3);
	//Class.TransmissionString("SaveTcpSetting", JSON.stringify(Global_TcpSetting), Result_4);
	//Class.TransmissionString("SaveTcpScalingVariable", JSON.stringify(Global_TcpScalingVariable), Result_5);
	//Class.TransmissionString("SaveTcpBitwiseVariable", JSON.stringify(Global_TcpBitwiseVariable), Result_6);
	var SetInterval = setInterval(function()
	{
		if(Result_1["Input"] == true)
		{
			Result["Input"] = true;
			Class = null; delete Class;
			clearInterval(SetInterval);
		}
	},500);
}











//第2頁
RemoteMqttGroupSecondPage.prototype._SetInitialValue_ = function(number)
{
	RemoteMqttGroupSecondPage.prototype._SetFormInitialValue_(number);
}

RemoteMqttGroupSecondPage.prototype._SetFormInitialValue_ = function(number)
{
	var RemoteMqttGroupClientSettings = $("#Main_Center-Content").find(".Body").eq(2).find(".Form").eq(0).find(".Row");
	RemoteMqttGroupClientSettings.eq(0).find(".Text").val(number);
	RemoteMqttGroupClientSettings.eq(1).find(".Text").val(Global_RemoteMqttGroup[number]["Name"]);

	var Class=new LoadFile();
	var ModuleType = Class.ReadFile("./File/RemoteMQTTGroup/ModuleType.json");
	var Value = ModuleType["Value"];
	var Text = ModuleType["Text"];
	var DataSettingForm = $("#Main_Center-Content").find(".Body").eq(2).find(".Form").eq(1);
	var DataSettingSelect = DataSettingForm.find(".Row").eq(0).find("table").find("tr").eq(0).find(".Select");
	DataSettingSelect.empty();
	DataSettingForm.find(".Row").eq(0).find("table").find("tr").find(".Select").empty();;
	for(var i=0; i<Value.length; i++)
	{
		DataSettingSelect.append($("<option></option>").attr("value",Value[i]).text(Text[i]));
	}
	RemoteMqttGroupSecondPage.prototype._SetInitDataSetting_(number);
	//ModuleType = DataSettingSelect.val();
	//RemoteMqttGroupSecondPage.prototype._ChangeInputModuleType_(ModuleType, that);
}
RemoteMqttGroupSecondPage.prototype._SetInitDataSetting_ = function(number)
{
	var InputForm = $("#Main_Center-Content").find(".Body").eq(2).find(".Form").eq(1);
	//InputForm.find(".Row").eq(0).find("table").find("tr").eq(0).find(".Select").val("");
	InputForm.find(".Row").eq(0).find("table").find("tr").find(".Select").val("");
	InputForm.find(".Row").eq(0).find("table").find("tr").find(".Text").val("");
	var TextArea = InputForm.find(".Row").eq(0).find(".Textarea");
	TextArea.val(Global_RemoteMqttGroup[number]["DataMessage"]);
}


RemoteMqttGroupSecondPage.prototype._ChangeInputModuleType_ = function(ModuleType, that)
{
	RemoteMqttGroupSecondPage.prototype._LoadModuleNumber_(ModuleType, that);
	RemoteMqttGroupSecondPage.prototype._LoadModuleName_(ModuleType, that);
	
	RemoteMqttGroupSecondPage.prototype._LoadInputVariableAttribute_(ModuleType);
	var ModuleNumber=$(that).closest(".Form").find(".Row").eq(0).find("table").find("tr").eq(1).find("Select").val();
	RemoteMqttGroupSecondPage.prototype._ChangeVariableAttribute_(ModuleType, that);
	/*PidOperationSecondPage.prototype._LoadVariableType_(ModuleType, that);
	
	var ModuleNumber=$(that).closest(".Form").find(".Row").eq(0).find("table").find("tr").eq(1).find("Select").val();
	var VariableIndex=PidOperationSecondPage.prototype._GetVariableIndexPrefixWord_(that);
	PidOperationSecondPage.prototype._LoadVariableName_(ModuleType, ModuleNumber, VariableIndex, that);
	
	PidOperationSecondPage.prototype._HideErrorMessage_();
	PidOperationSecondPage.prototype._ShowInputErrorMessage_();
	PidOperationSecondPage.prototype._ShowOutputErrorMessage_();*/
}
RemoteMqttGroupSecondPage.prototype._LoadModuleNumber_ = function(ModuleType, that)
{
	var ModuleVariable=RemoteMqttGroupSecondPage.prototype._GetModuleVariable_(ModuleType);
	var Class=new GetValue();
	var ModuleNumber=Class.GetModuleAllNumber(ModuleVariable);

	var Tr=$(that).closest(".Form").find(".Row").eq(0).find("table").find("tr");
	var Select = Tr.eq(1).find(".Select");
	Select.empty();
	if(ModuleNumber.length == 0)
	{
		return 0;
	}
	for(var i=0; i<ModuleNumber.length; i++)
	{
		Select.append($("<option></option>").attr("value",ModuleNumber[i]).text(ModuleNumber[i]));
	}
	Class=null;
}
RemoteMqttGroupSecondPage.prototype._GetModuleVariable_ = function(Module)
{
	var Internel = new Object();
	Internel["LAN"] = Global_RegisterModule;
	var Return;
	if(Module=="MRTU" || Module=="MRTU Scaling")			{Return=Global_RtuModule;}
	else if(Module=="MTCP"|| Module=="MTCP Scaling")		{Return=Global_TcpModule;}
	else if(Module=="MASCII"|| Module=="MASCII Scaling")	{Return=Global_AsciiModule;}
	else if(Module=="EIP")	{Return=Global_EipModule;}
	else if(Module=="MQTT")	{Return=Global_MqttModule;}
	else if(Module=="Internel")	{Return=Internel;}
	return Return;
}
RemoteMqttGroupSecondPage.prototype._ChangeModuleNumber_ = function(ModuleType, that)
{
	RemoteMqttGroupSecondPage.prototype._LoadModuleName_(ModuleType, that);
	
	var ModuleNumber=$(that).closest(".Form").find(".Row").eq(0).find("table").find("tr").eq(1).find("Select").val();
	var VariableIndex=PidOperationSecondPage.prototype._GetVariableIndexPrefixWord_(that);
	RemoteMqttGroupSecondPage.prototype._LoadVariableName_(ModuleType, ModuleNumber, VariableIndex, that);
	
	RemoteMqttGroupSecondPage.prototype._HideErrorMessage_();
	RemoteMqttGroupSecondPage.prototype._ShowInputErrorMessage_();
	RemoteMqttGroupSecondPage.prototype._ShowOutputErrorMessage_();
}

RemoteMqttGroupSecondPage.prototype._LoadModuleName_ = function(ModuleType, that)
{
	var ModuleVariable=RemoteMqttGroupSecondPage.prototype._GetModuleVariable_(ModuleType);
	var Select=$(that).closest("table").find("tr").eq(1).find(".Select");
	var ModuleNumber=Select.val();
	var Class=new GetValue();
	var ModuleName=Class.GetModuleName(ModuleVariable, ModuleNumber);
	
	var Text = $(that).closest("table").find("tr").eq(2).find(".Text");
	Text.val(ModuleName);
	Class=null;
}
RemoteMqttGroupSecondPage.prototype._LoadInputVariableAttribute_ = function(ModuleType)
{
	var Class=new LoadFile();
	var VariableAttribute = Class.ReadFile("./File/RemoteMQTTGroup/VariableAttribute.json");

	var InputForm = $("#Main_Center-Content").find(".Body").eq(2).find(".Form").eq(1);
	if(ModuleType =="")
	{
		ModuleType=InputForm.find(".Row").eq(0).find("tr").eq(0).find(".Select").val();
	}
	var Value=VariableAttribute[ModuleType]["Value"];
	var Text=VariableAttribute[ModuleType]["Text"];
	var DataSettingForm = $("#Main_Center-Content").find(".Body").eq(2).find(".Form").eq(1);
	var InputSelect = DataSettingForm.find(".Row").eq(0).find("table").find("tr").eq(3).find(".Select");
	InputSelect.empty();
	for(var i=0; i<Value.length; i++)
	{
		InputSelect.append($("<option></option>").attr("value",Value[i]).text(Text[i]));
	}
}
RemoteMqttGroupSecondPage.prototype._GetGlobalVariable_ = function(Module)
{	
	var Return;
	if(Module=="MRTU")			{Return=Global_RtuVariable;}
	else if(Module=="MTCP")		{Return=Global_TcpVariable;}
	else if(Module=="MASCII")	{Return=Global_AsciiVariable;}
	else if(Module=="MRTU Scaling")	{Return=Global_RtuScalingVariable;}
	else if(Module=="MTCP Scaling")	{Return=Global_TcpScalingVariable;}
	else if(Module=="EIP")	{Return=Global_EipVariable;}
	else if(Module=="MQTT")	{Return=Global_MqttVariable;}
	else if(Module=="Internel")	{Return=Global_RegisterVariable;}
	return Return;
}
RemoteMqttGroupSecondPage.prototype._ChangeVariableType_ = function(ModuleType, that)
{
	RemoteMqttGroupSecondPage.prototype._ChangeVariableAttribute_(ModuleType, that);
}
RemoteMqttGroupSecondPage.prototype._ChangeVariableAttribute_ = function(ModuleType, that)
{	
	var DataSettingForm = $("#Main_Center-Content").find(".Body").eq(2).find(".Form").eq(1);
	var Select = DataSettingForm.find(".Row").eq(0).find("table").find("tr").eq(4).find(".Select");
	var Variable = RemoteMqttGroupSecondPage.prototype._GetGlobalVariable_(ModuleType);
	var ModuleNumber = $(that).closest(".Form").find(".Row").eq(0).find("table").find("tr").eq(1).find("Select").val();
	var VariableType = $(that).closest(".Form").find(".Row").eq(0).find("table").find("tr").eq(3).find("Select").val();
	Select.empty();
	var key = Object.keys(Variable[ModuleNumber]);
	for(var i=0; i<key.length; i++)
	{
		if(key[i].indexOf(VariableType)>=0)
		{
			Select.append($("<option></option>").attr("value",Variable[ModuleNumber][key[i]]["VariableName"]).text(Variable[ModuleNumber][key[i]]["VariableName"]));
		}
	}
}
RemoteMqttGroupSecondPage.prototype._InputDataSetting_ = function()
{	
	var InputForm = $("#Main_Center-Content").find(".Body").eq(2).find(".Form").eq(1);
	var ModuleType = InputForm.find(".Row").eq(0).find("tr").eq(0).find(".Select").val();
	var ModuleNumber = InputForm.find(".Row").eq(0).find("tr").eq(1).find(".Select").val();
	var ModuleName = InputForm.find(".Row").eq(0).find("tr").eq(2).find(".Text").val();
	var VariableAttribute = InputForm.find(".Row").eq(0).find("tr").eq(3).find(".Select").val();
	var Variable = InputForm.find(".Row").eq(0).find("tr").eq(4).find(".Select").val();
	
	var Data = ModuleType + "_No." + ModuleNumber + "_" + ModuleName + "_" + VariableAttribute + "." + Variable;
	var TextArea = InputForm.find(".Row").eq(0).find(".Textarea");
	var OldData = TextArea.val();
	var NewData = OldData + Data;
	TextArea.val(NewData);
}
RemoteMqttGroupSecondPage.prototype._ConfirmButton_ = function(that)
{
	$(that).closest(".Form").find(".Message").hide();
	var Element = $("#Main_Center-Content").find(".Body").eq(2).find(".Message");
	for(var i=0; i<Element.length; i++)
	{
		if(Element.eq(i).is(":visible") == true){
			$(that).closest(".Row").find(".Message").show();
			return 0;
		}
	}
	RemoteMqttGroupSecondPage.prototype._SaveGlobalVariable_();
	$("#Main_Center-Content").find(".Body").eq(2).find(".FormTitle").eq(0).text("");
	$("#Main_Center-Content").find(".Body").eq(2).hide();
	$("#Main_Center-Content").find(".Body").eq(1).show();
	$("#Main_Center-Content").css("border-left-width", "1px");
	$("#Main_Center-Content").css("width", "795px");
	$("#Main_Left-List").show();
	RemoteMqttGroupFirstPage.prototype._RedisplayUi_();

	var Class = new Path();
	Class.LoadPathHtml($("#Left-List-RemoteMqttGroup").text(), 1, "main_PathRemoteMqttGroup_click(this)");
	Class = null;
}
RemoteMqttGroupSecondPage.prototype._SaveGlobalVariable_ = function()
{
	var RemoteMqttGroupClientSettings = $("#Main_Center-Content").find(".Body").eq(2).find(".Form").eq(0).find(".Row");
	var number = RemoteMqttGroupClientSettings.eq(0).find(".Text").val();
	var ModuleName = RemoteMqttGroupClientSettings.eq(1).find(".Text").val();
	var InputForm = $("#Main_Center-Content").find(".Body").eq(2).find(".Form").eq(1);
	var TextArea = InputForm.find(".Row").eq(0).find(".Textarea");
	var TextAreaData = TextArea.val();
	Global_RemoteMqttGroup[number]["Name"] = ModuleName;
	Global_RemoteMqttGroup[number]["DataMessage"] = TextAreaData;
	
}

RemoteMqttGroupSecondPage.prototype._NoConfirmButton_ = function()
{
	$("#Main_Center-Content").find(".Body").eq(2).find(".FormTitle").eq(0).text("");
	$("#Main_Center-Content").find(".Body").eq(2).hide();
	$("#Main_Center-Content").find(".Body").eq(1).show();
	$("#Main_Center-Content").css("border-left-width", "1px");
	$("#Main_Center-Content").css("width", "795px");
	$("#Main_Left-List").show();
	var Class = new Path();
	Class.LoadPathHtml($("#Left-List-RemoteMqttGroup").text(), 1, "main_PathRemoteMqttGroup_click(this)");
	Class = null;
}
