XVModuleSecondPage.prototype._CheckModuleName_ = function(that)
{
	$(that).closest(".Row").find(".Message").hide();
	var Name = $(that).closest(".Row").find(".Text").val();
	var Class = new Type();
	if(Name == ""){
		$(that).closest(".Row").find(".Message").eq(0).show();
	}
	else if(Class.CheckSpecialSymbols(Name) == true)
	{
		$(that).closest(".Row").find(".Message").eq(1).show();
	}
	else if(Class.CheckChineseLanguage(Name) == true)
	{
		$(that).closest(".Row").find(".Message").eq(1).show();
	}
	Class = null;
}

XVModuleSecondPage.prototype._CheckVariableName_ = function(that)
{
	
	let Element = $(that).closest(".Table").find(".DynamicRow");
	Element.find(".Message").hide();
	let CurrentlyName=$("#"+that.id).val();
	let strAry = that.id.split('_');
	let type=strAry[0];
	var ch=parseInt(strAry[1]);
	let IsNameRepeat=false;

	if(XVModuleSecondPage.prototype._IsNameFormat_(CurrentlyName) == false)
	{
		$("#"+that.id).closest(".Column").find(".Message").eq(1).show();
		return;
	}

	for (let index = 0; index < XVModule_Temp[type].length; index++) {
		
		let id= type+"_"+index+"_Name";
		if(id==that.id)
			continue;

		if(CurrentlyName==$("#"+id).val()){
			$("#"+that.id).closest(".Column").find(".Message").eq(0).show();
				IsNameRepeat=true;
		}	
	}
	
	if(IsNameRepeat==false)
		XVModule_Temp[type][ch].Name=CurrentlyName;

}

XVModuleSecondPage.prototype._GetTableVariableValue_ = function(that)
{

}

XVModuleSecondPage.prototype._IsNameFormat_ = function(Name)
{
	var Return=true, Class = new Type();
	if(Class.CheckChineseLanguage(Name) == true ||
	   Class.CheckSpecialSymbols(Name) == true ||
	   Name == "")
	{
		Return=false;
	}
	return Return;
}


XVModuleFirstPage.prototype._BuildXVModuleAllObject_ = function(that)
{  
	
	XVModuleFirstPage.prototype._BuildXVModuleObject_(XVModule_Temp.Model);
	//_CreateXVVariableObject
	//XVModuleSecondPage.prototype._XVToOpcuaVariableSetting_();
	//XVModuleSecondPage.prototype._XVToMqttVariableSetting_();
	
}
function generate_XV_template(Model)
{
	var XV_config=XVModuleSpec[Model] || null;

  	if(XV_config)
	{
    	XVModule_Temp.DI=[];
		XVModule_Temp.Counter=[];
		for (let index = 0; index < XV_config.DI; index++) {
			 XVModule_Temp.DI[index]={};
     		 XVModule_Temp.DI[index]["Name"]="DI"+index;
			//XVModule_Temp.DI[index]["Type"]="bool";
			
			 XVModule_Temp.DI[index].Description="";

			 XVModule_Temp.Counter[index]={};
			 XVModule_Temp.Counter[index]["Name"]="Counter"+index;
			//falling edge =0, rising edge=1
			 XVModule_Temp.Counter[index].Mode=0;
			 XVModule_Temp.Counter[index].Description="";
		}
	
		XVModule_Temp["DO"]=[];
		let temp="DO";
		switch(Model)
		{
			case "XV-116":
			case "XV-119":
			case "XV-303":
			case "XV-306":
			case "XV-307":
				temp="RL";
				break;
		}
 		for (let index = 0; index < XV_config.DO; index++) {
    		XVModule_Temp.DO[index]={};
			XVModule_Temp["DO"][index]["Name"]=temp+index;
			//XVModule_Temp["DO"][index]["Type"]="bool";
			XVModule_Temp["DO"][index]["PowerOn"]=0;
			XVModule_Temp.DO[index].Description="";
		}
	
		XVModule_Temp["AI"]=[];
		for (let index = 0; index < XV_config.AI; index++) {
    		XVModule_Temp.AI[index]={};
			XVModule_Temp["AI"][index]["Name"]="AI"+index;
			//XVModule_Temp["AI"][index]["Type"]="float";
			XVModule_Temp["AI"][index]["TypeCode"]=8;
			XVModule_Temp.AI[index].Description="";
		}

		XVModule_Temp["AO"]=[];
    	for (let index = 0; index < XV_config.AO; index++) {
      		XVModule_Temp.AO[index]={};  
			XVModule_Temp["AO"][index]["Name"]="AO"+index;
			//XVModule_Temp["AO"][index]["Type"]="float";
			XVModule_Temp["AO"][index]["TypeCode"]=2;
			XVModule_Temp["AO"][index]["PowerOn"]=0;
			XVModule_Temp.AO[index].Description="";
		}
	}
}
XVModuleFirstPage.prototype._BuildXVModuleObject_ = function(ModuleName)
{
	generate_XV_template(ModuleName);

}

XVModuleFirstPage.prototype._RedisplayUi_ = function()
{
	
	if(Global_XVModule["Model"] === undefined)
	{
		$("#XVModel")[0].selectedIndex=0;
		$("#XVModuleSetting").prop('disabled', false);
	}
	else
	{
		$("#XVModel").val(Global_XVModule["Model"]).change();
	}
	
}

XVModuleFirstPage.prototype._LoadLanName_ = function()
{
	var Class = new LoadFile();
	
	Class = null;
}


XVModuleFirstPage.prototype._Initialization_ = function()
{

	XVModuleFirstPage.prototype._RedisplayUi_();
}

XVModuleFirstPage.prototype._TransmissionJson_ = function(ssocket, Command, string, Callback)
{
	var Length=20000, index=0;  var array = new Array("Start","");
	ssocket.emit(Command, array);	
	ssocket.on(Command, function (Return) {
		if(Return == "Start" || Return == "Send")
		{
			if(string.length > (index+Length)){
				array = new Array("Send", string.substring(index, index+Length));
			}
			else if(string.length <= (index+Length)){
				array = new Array("End", string.substring(index, string.length));
			}
			index = index + Length;
			ssocket.emit(Command, array);	
		}
		else if(Return == "End")
		{
			Callback();
		}
	});
}

XVModuleFirstPage.prototype._SaveModuleSetting_ = function(Result)
{
	var Result_1={"Input":null}, Result_2={"Input":null}, Result_3={"Input":null}, Result_4={"Input":null};
	var Class = new Transmission();
	Class.TransmissionString("SaveXVVariable", JSON.stringify(Global_XVVariable), Result_1);
	Class.TransmissionString("SaveXVModule", JSON.stringify(Global_XVModule), Result_2);

	var SetInterval = setInterval(function()
	{
		if(Result_1["Input"]==true && Result_2["Input"]==true/* && Result_3["Input"]==true && Result_4["Input"]==true*/)
		{
			clearInterval(SetInterval);
			Result["Input"] = true;
		}
	},500);
}

XVModuleFirstPage.prototype._SaveConvertSetting_ = function(Result)
{
	var Result_1={"Input":null}, Result_2={"Input":null}, Result_3={"Input":null};
	var Class = new Transmission();

	if(Object.keys(Global_XVModule).length!==0)
		XVModuleSecondPage.prototype._XVToOpcuaVariableSetting_();

	Class.TransmissionString("SaveXVToOpcuaVariable", JSON.stringify(Global_XVToOpcuaVariable), Result_1);
	//Class.TransmissionString("SaveXVToMqttSetting", JSON.stringify(Global_XVToMqttSetting), Result_2);
	//Class.TransmissionString("SaveXVToMqttVariable", JSON.stringify(Global_XVToMqttVariable), Result_3);
	var SetInterval = setInterval(function()
	{
		if(Result_1["Input"]==true /*&& Result_2["Input"]==true && Result_3["Input"]==true*/)
		{
			clearInterval(SetInterval);
			Result["Input"] = true;
		}
	},500);
}

XVModuleFirstPage.prototype._SaveDataLayerAndServiceLayerVariables_ = function(Result)
{
	var Result_1={"Input":null}, Result_2={"Input":null};

	XVModuleFirstPage.prototype._SaveModuleSetting_(Result_1);
	XVModuleFirstPage.prototype._SaveConvertSetting_(Result_2);

	var SetInterval = setInterval(function()
	{
		if(Result_1["Input"]==true && Result_2["Input"]==true)
		{
			clearInterval(SetInterval);
			Result["Input"] = true;
		}
	},500);
}

XVModuleFirstPage.prototype._EditButton_ = function(that)
{
	$("#DITable").find(".DynamicRow").remove();
	$("#CounterTable").find(".DynamicRow").remove();
	$("#DOTable").find(".DynamicRow").remove();
	$("#AITable").find(".DynamicRow").remove();
	$("#AOTable").find(".DynamicRow").remove();
	$("#Main_Center-Content").find(".Body").eq(1).find(".Message").hide();
	//var number = parseInt($(that).closest(".DynamicRow").find(".Column").eq(1).text());
    var number = 1;

	$("#Main_Center-Content").find(".Body").eq(0).hide();
	$("#Main_Center-Content").find(".Body").eq(1).show();
	var Name = $("#Main_Center-Content").find(".Body").eq(1).find(".FormTitle").eq(0).text();

	var Class = new Path();
	Class.LoadPathHtml(Name, 2);
	Class = null;
	XVModuleSecondPage.prototype._SetInitialValue_(number);

	let type_array=["DI","Counter","DO","AI","AO"];
	function generate_XVitem(value, index, array)
	{
		for (let index = 0; index < XVModule_Temp[value].length; index++) {
			XVModuleSecondPage.prototype._CreatAndJoinFormSetting_(value, index);
		}
	}
	type_array.forEach(generate_XVitem);
	
}


function set_XVItemCounterType(type,channel)
{
	if(XVModule_Temp["Counter"][channel].Mode===1)
	{
		$("#Ch_CounterType").val("1");
	}
	else
	{
		$("#Ch_CounterType").val("0");
	}

	$("#Ch_CounterType").attr("id", type+"_"+channel+"_CNTRType" );
	
}

function set_XVItemDOPowerOn(channel)
{
	if(XVModule_Temp["DO"][channel].PowerOn===1)
	{
		$("#Ch_PowerOn").val("1");
	}
	else
	{
		$("#Ch_PowerOn").val("0");
	}
	
	$("#Ch_PowerOn").attr("id", "DO_"+channel+"_PowerOn" );
}

function set_XVItemAIORange(type,channel)
{
	$("#Ch_Range").val(XVModule_Temp[type][channel].TypeCode);
	$("#Ch_Range").attr("id",type+"_"+channel+"_Range");
}

function set_XVItemAOPowerOn(channel)
{
	
	$("#Ch_PowerOn").val(XVModule_Temp["AO"][channel].PowerOn);
	$("#Ch_PowerOn").attr("id", "AO_"+channel+"_PowerOn" );
	
    let range={};
	switch(XVModule_Temp["AO"][channel].TypeCode)
	{
		case 0:
			range={"max":20,"min":0};
			break;
		case 1:
			range={"max":20,"min":4};
			break;
		case 2:
			range={"max":10,"min":0};
			break;
		case 3:
			range={"max":10,"min":-10};
			break;
		case 4:
			range={"max":5,"min":0};
			break;
		case 5:
			range={"max":5,"min":-5};
			break;
	}
		$("#AO_"+channel+"_PowerOn").attr(range);

	
}

function add_XVItem(type,channel)
{
    switch (type) {
		case 'DI':
			 break;
		case 'Counter':		
			set_XVItemCounterType(type,channel);
			 break;
		case 'DO':
			set_XVItemDOPowerOn(channel);
			break;
		case 'AI':
			set_XVItemAIORange(type,channel);
			break;
		case 'AO':
			set_XVItemAIORange(type,channel);
			set_XVItemAOPowerOn(channel);
			break;
	  }
	//set_XVItemNum(Type,channel);
	$("#Ch_Num").text(channel);
	$("#Ch_Num").attr("id", type+"_"+channel+"_Num" );
	//set_XVItemName(Type,channel);
	$("#Ch_Name").val(XVModule_Temp[type][channel].Name);
	$("#Ch_Name").attr("id", type+"_"+channel+"_Name" );
	//set_XVItemDescription(Type,channel)
	$("#Ch_Desc").val(XVModule_Temp[type][channel].Description);
	$("#Ch_Desc").attr("id", type+"_"+channel+"_Desc" );
}

XVModuleSecondPage.prototype._CreatAndJoinFormSetting_ = function(Type, channelIndex)
{
	var html = "", TempHtml="";
	switch (Type) {
		case 'DI':
			TempHtml = $("#DI_Ch").clone().html();
			 break;
		case 'Counter':
			TempHtml = $("#Counter_Ch").clone().html();
			 break;
		case 'DO':
			TempHtml = $("#DO_Ch").clone().html();
			break;
		case 'AI':
			TempHtml = $("#AI_Ch").clone().html();
			break;
		case 'AO':
			TempHtml = $("#AO_Ch").clone().html();
			 break;
	  }

	  html = html + TempHtml;
	  var Name = '#' + Type + 'Table';
	  $(Name).append(html);
	  var itemId= Type + '_';
	  $('#'+itemId).attr("id", itemId+channelIndex );
	  add_XVItem(Type, channelIndex);
}


XVModuleFirstPage.prototype._SaveButton_ = function(that)
{
	
	let objectkey=Object.keys(Global_XVModule);
	if(objectkey.length===0)
		return ; 
	let model=$("#XVModel option:selected" ).text();
	if(model==="None")
	{
		Global_XVModule={};
		Global_XVVariable={};
		Global_XVToOpcuaVariable={};
	}
	that.disabled = true;
	var Result={"Input":null};
	$(that).closest('.Row').find(".Loading").show();
	$(that).closest('.Row').find(".Message").hide();
	
	XVModuleFirstPage.prototype._SaveDataLayerAndServiceLayerVariables_(Result);
	var SetInterval = setInterval(function()
	{
		if(Result["Input"] == true)
		{
			clearInterval(SetInterval);
			$(that).closest('.Row').find(".Loading").hide();
			$(that).closest('.Row').find(".Message").eq(0).show();
		}
		that.disabled = true;
	},500);
}



XVModuleSecondPage.prototype._SaveChangeChannelValue_ = function(number)
{
	
}

XVModuleSecondPage.prototype._SetInitialValue_ = function(number)
{
	
	XVModuleSecondPage.prototype._ClearForm_();
	XVModuleSecondPage.prototype._ClearDataModelTable_();
	XVModuleSecondPage.prototype._ClearTotalTable_();
	
	$("#XV_ModbuleName").val(XVModule_Temp.Model||"");
    $("#XV_NickName").val(XVModule_Temp.Name||"");
	
}

XVModuleSecondPage.prototype._ClearForm_ = function()
{

}

XVModuleSecondPage.prototype._ClearDataModelTable_ = function()
{

}

XVModuleSecondPage.prototype._ClearTotalTable_ = function()
{

}

var generate_XV_Variable =function ()
{
	Global_XVVariable={};
	Global_XVVariable["1"]={};
	

	for (let index = 0; index < Global_XVModule.AI.length; index++) {
		let id="AI-Float-"+index.toString();
		Global_XVVariable["1"][id]={};
		Global_XVVariable["1"][id]["VariableName"]=Global_XVModule.AI[index].Name;
		Global_XVVariable["1"][id]["Description"]=Global_XVModule.AI[index].Description;
	}

	for (let index = 0; index < Global_XVModule.AO.length; index++) {
		let id="AO-Float-"+index.toString();
		Global_XVVariable["1"][id]={};
		Global_XVVariable["1"][id]["VariableName"]=Global_XVModule.AO[index].Name;
		Global_XVVariable["1"][id]["Description"]=Global_XVModule.AO[index].Description;
	}

	for (let index = 0; index < Global_XVModule.DI.length; index++) {
		let id="DI-Bool-"+index.toString();
		Global_XVVariable["1"][id]={};
		Global_XVVariable["1"][id]["VariableName"]=Global_XVModule.DI[index].Name;
		Global_XVVariable["1"][id]["Description"]=Global_XVModule.DI[index].Description;
	}

	for (let index = 0; index < Global_XVModule.Counter.length; index++) {
		let id="Counter-Unsigned Long-"+index.toString();
		Global_XVVariable["1"][id]={};
		Global_XVVariable["1"][id]["VariableName"]=Global_XVModule.Counter[index].Name;
		Global_XVVariable["1"][id]["Description"]=Global_XVModule.Counter[index].Description;
	}

	for (let index = 0; index < Global_XVModule.DO.length; index++) {
		let id="DO-Bool-"+index.toString();
		Global_XVVariable["1"][id]={};
		Global_XVVariable["1"][id]["VariableName"]=Global_XVModule.DO[index].Name;
		Global_XVVariable["1"][id]["Description"]=Global_XVModule.DO[index].Description;
	}

}

XVModuleSecondPage.prototype._ConfirmButton_ = function(that)
{

	$(that).closest(".Form").find(".Message").hide();
   //$("#SettingForm").find(".Message").hide();
    var Element = $("#Main_Center-Content").find(".Body").eq(1).find(".Message");
    for (var i = 0; i < Element.length; i++) {
        if (Element.eq(i).is(":visible") == true && Element.eq(i).css("color") != "rgb(34, 119, 0)") {
            $(that).closest(".Form").find(".Message").eq(1).show();
            return 0;
        }
    }	

	XVModule_Temp.Name=$("#XV_NickName").val();
	Global_XVModule=Object.assign({}, XVModule_Temp);
	generate_XV_Variable();
	$("#Main_Center-Content").find(".Body").eq(1).hide();
	$("#Main_Center-Content").find(".Body").eq(0).show();
	XVModuleFirstPage.prototype._RedisplayUi_();
	
	//XVModuleSecondPage.prototype._SaveChangeChannelValue_(number);
	var Class = new Path();
	Class.LoadPathHtml($("#Left-List-XV").text(), 1, "main_PathXVModule_click(this)");
	Class = null;
}

XVModuleSecondPage.prototype._NoConfirmButton_ = function(that)
{
	$("#Main_Center-Content").find(".Body").eq(1).hide();
	$("#Main_Center-Content").find(".Body").eq(0).show();
	$("#VariableTable").find(".DynamicRow").remove();
	var Class = new Path();
	Class.LoadPathHtml($("#Left-List-XV").text(), 1, "main_PathXVModule_click(this)");
	Class = null;
}

XVModuleSecondPage.prototype._XVToOpcuaVariableSetting_ = function()
{
	//var Return;
	let SystemVariableName;
	let VariableType, VariableAttribute;
	//var ModuleName = XVModule_Temp.Name;
	Global_XVToOpcuaVariable={};

	Global_XVToOpcuaVariable["1"]= new Object();

	for (let index = 0; index < Global_XVModule.DI.length; index++) {
		VariableType="Bool";
		VariableAttribute="DI"
		SystemVariableName=VariableAttribute+"-"+VariableType+"-"+index;
		Global_XVToOpcuaVariable["1"][SystemVariableName] = new Object();
		Global_XVToOpcuaVariable["1"][SystemVariableName]["TransformOpcUa"] = false;
	}


    for (let index = 0; index < Global_XVModule.Counter.length; index++) {
		VariableType="Unsigned Long";
		VariableAttribute="Counter"
		SystemVariableName=VariableAttribute+"-"+VariableType+"-"+index;
		Global_XVToOpcuaVariable["1"][SystemVariableName] = new Object();
		Global_XVToOpcuaVariable["1"][SystemVariableName]["TransformOpcUa"] = false;
	}

	for (let index = 0; index < Global_XVModule.DO.length; index++) {
		VariableType="Bool";
		VariableAttribute="DO"
		SystemVariableName=VariableAttribute+"-"+VariableType+"-"+index;
		Global_XVToOpcuaVariable["1"][SystemVariableName] = new Object();
		Global_XVToOpcuaVariable["1"][SystemVariableName]["TransformOpcUa"] = false;
	}

	for (let index = 0; index < Global_XVModule.AI.length; index++) {
		VariableType="Float";
		VariableAttribute="AI"
		SystemVariableName=VariableAttribute+"-"+VariableType+"-"+index;
		Global_XVToOpcuaVariable["1"][SystemVariableName] = new Object();
		Global_XVToOpcuaVariable["1"][SystemVariableName]["TransformOpcUa"] = false;
	}

	for (let index = 0; index < Global_XVModule.AO.length; index++) {
		VariableType="Float";
		VariableAttribute="AO"
		SystemVariableNameGlobal_Global_XVToOpcuaVariable=VariableAttribute+"-"+VariableType+"-"+index;
		Global_XVToOpcuaVariable["1"][SystemVariableName] = new Object();
		Global_XVToOpcuaVariable["1"][SystemVariableName]["TransformOpcUa"] = false;
	}

}

XVModuleSecondPage.prototype._XVToMqttVariableSetting_ = function()
{
	Global_XVToMqttVariable={};
	
}

XVModuleSecondPage.prototype._SetChannelType_ = function(that)
{
	let strAry = that.id.split('_');
	let type=strAry[0];
    let ch=parseInt(strAry[1]);
	let TypeCode=parseInt($("#"+that.id).val());
	XVModule_Temp[type][ch].TypeCode =TypeCode;

	if(type=="AO")
	{
        let range={};
		switch(TypeCode)
		{
			case 0:
				range={"max":20,"min":0};
				break;
			case 1:
				range={"max":20,"min":4};
				break;
			case 2:
				range={"max":10,"min":0};
				break;
			case 3:
				range={"max":10,"min":-10};
				break;
			case 4:
				range={"max":5,"min":0};
				break;
			case 5:
				range={"max":5,"min":-5};
				break;
		}
		$("#AO_"+ch+"_PowerOn").attr(range);

	}
}

XVModuleSecondPage.prototype._SetChannelPowerOn_ =function(that)
{
	let strAry = that.id.split('_');
	let type=strAry[0];
    let ch=parseInt(strAry[1]);
	if(type==="AO")
	{
		let max=parseFloat($("#"+that.id).attr("max"));
		let min=parseFloat($("#"+that.id).attr("min"));
		let value =parseFloat(that.value);
		if(max>= value && min<=value)
		{
			XVModule_Temp["AO"][ch].PowerOn=value;
		}
		else
		{
     	 	let newvalue=(value>max)?max:min;  
	  	 	$("#"+that.id).val(newvalue);
	   		XVModule_Temp["AO"][ch].PowerOn=newvalue;
		}
	}
	else if(type==="DO")
	{

		XVModule_Temp["DO"][ch].PowerOn=parseInt(that.value);
	}
    
}

XVModuleSecondPage.prototype._SetChannelDescription_ = function(that)
{
	let strAry = that.id.split('_');
	let type=strAry[0];
    let ch=parseInt(strAry[1]);
	XVModule_Temp[type][ch].Description =$("#"+that.id).val(); 
}

XVModuleSecondPage.prototype._SetCounterMode_ = function(that)
{
	let strAry = that.id.split('_');
	let type=strAry[0];
    let ch=parseInt(strAry[1]);
	XVModule_Temp[type][ch].Mode =parseInt($("#"+that.id).val()); 
}

